      ****************************************************************
      * Copyright (C) Micro Focus 1988-2013. All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      * 
      ****************************************************************
       WORKING-STORAGE SECTION.

      *  Include the SQL Communications Area. This includes the
      *  definitions of SQLCODE, etc
       EXEC SQL INCLUDE SQLCA END-EXEC

           EXEC SQL BEGIN DECLARE SECTION END-EXEC
       01 SVR                PIC X(32).
       01 USR                PIC X(32).
       01 INT-COL            PIC S9(04) COMP-5.
       01 NVARCHAR-COL       PIC N(20) USAGE NATIONAL.
       01 NVARCHAR-COL-NULL  PIC S9(04)  COMP-5.
           EXEC SQL END DECLARE SECTION END-EXEC
       01 MFSQLMESSAGETEXT  PIC X(250).
       01 NVARCHAR-DISP      PIC X(60) VALUE SPACE.

      *
       PROCEDURE DIVISION.
       MAIN-PROC.

           EXEC SQL
             WHENEVER SQLERROR GO TO DB-Error
           END-EXEC.

           DISPLAY "Create/insert/update/select/drop test".
           DISPLAY " ".
      *    Connect to an SQL Server.
           DISPLAY "Enter data source (e.g. odbcdemo) "
                   WITH NO ADVANCING.
           ACCEPT SVR
         DISPLAY "Enter username[('.'|'/')password] (e.g. scott/tiger) "
                    WITH NO ADVANCING.
           ACCEPT USR.

      *    Connect to the specified database
           EXEC SQL
               CONNECT TO :SVR USER :USR WITH NO PROMPT
           END-EXEC.

           DISPLAY 'Create table'.
           EXEC SQL
               create table mfesqltest (
                   int_col  integer not null,
                   nvarchar_col nvarchar(20))
           END-EXEC.

           DISPLAY 'Insert first row'.
           MOVE 1 to INT-COL.
           MOVE N"alphanumeric value" TO NVARCHAR-COL.
           EXEC SQL
               insert into mfesqltest
                   (int_col, nvarchar_col) values
                   (:INT-COL, :NVARCHAR-COL)
           END-EXEC.

           DISPLAY 'Insert second row containing Japanese characters'.
           MOVE 2 to INT-COL.
           MOVE N"" TO NVARCHAR-COL.
           EXEC SQL
               insert into mfesqltest
                   (int_col, nvarchar_col) values
                   (:INT-COL, :NVARCHAR-COL)
           END-EXEC.

           DISPLAY 'Commit the insertion'.
           EXEC SQL
               commit transaction
           END-EXEC.

           DISPLAY 'Update row'.
           MOVE 2 TO INT-COL.
           MOVE N"Ă" TO NVARCHAR-COL.
           EXEC SQL
               update mfesqltest
                 set  nvarchar_col = :NVARCHAR-COL
                 where int_col = :INT-COL
           END-EXEC.

           DISPLAY 'Commit the change'.
           EXEC SQL
               commit transaction
           END-EXEC.

           DISPLAY 'Fetch '
           EXEC SQL
               declare vcurs cursor for
                   select int_col, nvarchar_col
                   from mfesqltest
           END-EXEC.

           EXEC SQL
               open vcurs
           END-EXEC.

           PERFORM UNTIL SQLSTATE >= "02000"
              EXEC SQL
                FETCH vcurs  INTO
                   :INT-COL
                  ,:NVARCHAR-COL:NVARCHAR-COL-NULL
              END-EXEC

              IF SQLSTATE < "02000"
                 MOVE FUNCTION DISPLAY-OF(NVARCHAR-COL) TO NVARCHAR-DISP
                 DISPLAY "************************************"
                 DISPLAY "int_col     : " INT-COL
                 DISPLAY "nvarchar_col: " NVARCHAR-DISP
              END-IF
           END-PERFORM.
           DISPLAY "************************************".

           EXEC SQL
               close vcurs
           END-EXEC.

      *    Start a new transaction to avoid mixing DML and DDL
      *    as this will upset some data sources
           EXEC SQL commit END-EXEC.

           DISPLAY 'Drop table'
           EXEC SQL
               drop table mfesqltest
           END-EXEC.

           DISPLAY 'Disconnect'
           EXEC SQL
               commit work release
           END-EXEC.

           DISPLAY "Test completed without error"

           STOP RUN.

       DB-Error Section.

           DISPLAY "SQL Error = " SQLSTATE " " SQLCODE.
           DISPLAY MFSQLMESSAGETEXT.
           EXEC SQL
               commit work release
           END-EXEC.
           STOP RUN.
